    001/*
    002 * Copyright (c) 2007-2016 Concurrent, Inc. All Rights Reserved.
    003 *
    004 * Project and contact information: http://www.cascading.org/
    005 *
    006 * This file is part of the Cascading project.
    007 *
    008 * Licensed under the Apache License, Version 2.0 (the "License");
    009 * you may not use this file except in compliance with the License.
    010 * You may obtain a copy of the License at
    011 *
    012 *     http://www.apache.org/licenses/LICENSE-2.0
    013 *
    014 * Unless required by applicable law or agreed to in writing, software
    015 * distributed under the License is distributed on an "AS IS" BASIS,
    016 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    017 * See the License for the specific language governing permissions and
    018 * limitations under the License.
    019 */
    020
    021package cascading.tuple;
    022
    023/**
    024 * The Hasher allows a {@link java.util.Comparator} implementation to also be delegated to during hashCode generation
    025 * during grouping partitioning.
    026 * <p/>
    027 * If a Comparator is used to compare two types during grouping, its likely the {@code hashCode} value between
    028 * the two objects will not be consistent. This allows to objects being equal to hash to the same bucket (reducer)
    029 * during partitioning.
    030 * <p/>
    031 * As of Cascading 3.0 null values will be passed to implementations of the Hasher interface.
    032 */
    033public interface Hasher<V>
    034  {
    035  /**
    036   * Return the hashCode of the given value.
    037   *
    038   * @param value may be null
    039   * @return int hashCode of given value
    040   */
    041  int hashCode( V value );
    042  }